using System;
using System.IO;
using System.Text;
using System.Data.OleDb;
using System.Data.SqlClient;
using NAMOMIMELib;


namespace as4bbs
{
	/// <summary>
	/// Summary description for AS4Board.
	/// Board action class
	/// </summary>
	public class AS4Board
	{
		private string uploadpath = "c:\\inetpub\\wwwroot\\as4bbs\\upload";
		private string uploadURL = "http://localhost/as4bbs/upload";
		
		SqlConnection con;

		public void SetUploadPath(string uploadPath, string uploadUrl)
		{
			this.uploadpath = uploadPath;
			this.uploadURL = uploadUrl;
		}

		private void OpenDataBase()
		{
			con = new SqlConnection("user id=web; password=test;initial catalog=web; data source=activextest");
			con.Open();
		}

		public void CloseBoard()
		{
			con.Close();
		}

		public bool WriteBoard(string author, string subject, string homepage, string email, string password, string MIMEContent)
		{
			int msgno = 0;
			string strSql;
			string contents;
			SqlCommand cmd;
			SqlDataReader reader;

			OpenDataBase();
			strSql = "select max(msgno) from board";
			cmd = new SqlCommand(strSql, con);
			reader = cmd.ExecuteReader();
			reader.Read();

			if(reader.IsDBNull(0))
				msgno = 0;
			else
				msgno = reader.GetInt32(0);

			reader.Close();
			msgno++;

			contents = DecodeMIME(MIMEContent, msgno.ToString());
			contents = Replace(contents, "'", "\\'");

			strSql = "insert into board (msgno, author, email, homepage, subject, msgbody, password, p_id, wtime) values (";
			strSql += msgno.ToString() + ", ";
			strSql += "'" + author + "', ";
			strSql += "'" + email + "', ";
			strSql += "'" + homepage + "', ";
			strSql += "'" + subject + "', ";
			strSql += "'" + contents + "', ";
			strSql += "'" + password + "', ";
			strSql += msgno.ToString() + ", ";
			strSql += "GETDATE());";

			cmd.CommandText = strSql;
			cmd.ExecuteNonQuery();
			reader.Close();
			return true;
		}

		public SqlDataReader ReadMessage(int msgno)
		{
			SqlCommand cmd;
			SqlDataReader reader;
			string cmdText;
		
			OpenDataBase();
			cmdText = "select msgno, subject, author, wtime, vcnt, homepage, email, msgbody from board where msgno = " + msgno;
			cmd = new SqlCommand(cmdText, con);
			reader = cmd.ExecuteReader();	
			reader.Read();	

			return reader;
		}

		public bool EditBoard(int msgno, string author, string subject, string homepage, string email, string password, string MIMEContent)
		{
			SqlCommand cmd;
			SqlDataReader reader;
			string cmdText;
			string orgPass;
			string bodymsg;

			cmdText = "select password from board where msgno = " + msgno.ToString();

			OpenDataBase();
			cmd = new SqlCommand(cmdText, con);
			reader = cmd.ExecuteReader();
			if(!reader.Read())
				return false;

			orgPass = reader.GetString(0);

			if(!orgPass.Equals(password))
				return false;

			reader.Close();

			bodymsg = DecodeMIME(MIMEContent, msgno.ToString());
			bodymsg = Replace(bodymsg, "'", "\\'");

			cmdText = "update board set subject='" + subject + "', ";
			cmdText += "homepage='" + homepage + "', ";
			cmdText += "email='" + email + "', ";
			cmdText += "author='" + author + "', ";
			cmdText += "wtime=GETDATE(), ";
			cmdText += "msgbody='" + bodymsg + "' ";
			cmdText += "where msgno=" + msgno;

			cmd.CommandText = cmdText;
			cmd.ExecuteNonQuery();
			con.Close();

			return true;
		}

		public bool DeleteBoard(int msgno, string password)
		{
			SqlCommand cmd;
			SqlDataReader reader;
			string cmdText;
			string orgPass;

			cmdText = "select password from board where msgno = " + msgno.ToString();
			OpenDataBase();
			cmd = new SqlCommand(cmdText, con);
			reader = cmd.ExecuteReader();

			if(!reader.Read())
				return false;
			orgPass = reader.GetString(0);
			if(!orgPass.Equals(password))
				return false;

			reader.Close();

			cmdText = "delete from board where msgno = " + msgno.ToString();
			cmd.CommandText = cmdText;
			cmd.ExecuteNonQuery();
			DeleteFilePath(msgno);

			con.Close();
			return true;
		}

		private bool DeleteFilePath(int msgno)
		{
			string dataFolder = uploadpath  + "\\" + msgno.ToString();
			DirectoryInfo di;
			FileInfo[] afi;
			di = new DirectoryInfo(dataFolder);
			afi = di.GetFiles();

			foreach(FileInfo fi in afi)
			{
				File.Delete(fi.FullName);
			}

			Directory.Delete(dataFolder);
			return true;
		}

		public bool ReplyBoard(int pMsgno, string author, string subject, string homepage, string email, string password, string MIMEContent)
		{
			int msgno = 0;
			int ppid = 0;
			int ptid = 0;
			int ptstep = 0;
			string strSql;
			string contents;
			SqlConnection con = new SqlConnection("user id=web; password=test;initial catalog=web; data source=activextest");
			SqlCommand cmd;
			SqlDataReader reader;

			OpenDataBase();
			strSql = "select max(msgno) from board";
			cmd = new SqlCommand(strSql, con);
			reader = cmd.ExecuteReader();
			reader.Read();

			if(reader.IsDBNull(0))
				msgno = 0;
			else
				reader.GetInt32(0);
			reader.Close();
			msgno++;

			contents = DecodeMIME(MIMEContent, msgno.ToString());
			contents = Replace(contents, "'", "\\'");

			strSql = "select msgno, p_id, t_id, t_step from board where msgno = " + pMsgno.ToString();
			cmd.CommandText = strSql;
			reader = cmd.ExecuteReader();
			reader.Read();

			if(reader.IsDBNull(0))
				return false;

			ppid = reader.GetInt32(0);
			ptid = reader.GetInt32(1);
			ptstep = reader.GetInt32(2);

			reader.Close();

			strSql = "insert into board (msgno, author, email, homepage, subject, msgbody, p_id, t_id, t_step, wtime) values (";
			strSql += msgno.ToString() + ", ";
			strSql += "'" + author + "', ";
			strSql += "'" + email + "', ";
			strSql += "'" + homepage + "', ";
			strSql += "'" + subject + "', ";
			strSql += "'" + contents + "', ";
			strSql += ppid.ToString() + ", ";
			strSql += ptid.ToString() + ", ";
			strSql += ptstep.ToString() + ", ";
			strSql += "GETDATE());";

            cmd.CommandText = strSql;
			cmd.ExecuteNonQuery();
			return true;
		}

		// Mime decoding
		private string DecodeMIME(string MIMEContent, string msgno)
		{
			string bodymsg;
			string dataFolder;
			string dataUrl;
			DirectoryInfo di;
			FileInfo[] afi;
			MIMEObjectClass mime = new MIMEObjectClass();

			// save included file
			dataFolder = uploadpath + "\\" + msgno;
			dataUrl = uploadURL + "/" + msgno;
			Directory.CreateDirectory(dataFolder);
			mime.Decode(MIMEContent, dataFolder);

			// file reading 
			FileStream freader = File.OpenRead(dataFolder + "\\noname.htm");
			byte[] buffer = new byte[freader.Length];
			freader.Read(buffer, 0, (int)freader.Length);
			bodymsg = Encoding.Default.GetString(buffer);
			freader.Close();
			File.Delete(dataFolder + "\\noname.htm");
			di = new DirectoryInfo(dataFolder);
			afi = di.GetFiles();

			foreach(FileInfo fi in afi)
			{
				bodymsg = Replace(bodymsg, fi.Name, uploadURL + "/" + msgno + "/" + fi.Name);
			}

			return bodymsg;
		}

		public string ConvertHtmlChars(string source)
		{
			string convert;
			convert = Replace(source, "<", "&lt;");
			convert = Replace(convert, ">", "&gt;");
			convert = Replace(convert, "\"", "&quot;");
			convert = Replace(convert, "&nbsp;", "&amp;nbsp;");

			return convert;
		}
		private string Replace(string source, string oldValue, string newValue)
		{
			StringBuilder sb;

			sb = new StringBuilder(source);
			sb.Replace(oldValue, newValue);
			return sb.ToString();
		}
	}
}
